-- by Frvetz
-- Contact: SlipDestroysFields@web.de
-- Date 09.05.2022


--[[


TUTORIAL


##English##

-Step-To-Step Guide for adjusting the values-

	- 1. Unzip the Mod

	- 2. Open the file "registerSlipDestroysFields.lua"

	- 3. Look for the lines 	'registerSlipDestroysFields.Strength = 1.8		-- Option "Little Destruction" '		at the end of the script (lines 95-99)
								'registerSlipDestroysFields.Strength = 1.65 	-- Option "Medium Destruction" '
								'registerSlipDestroysFields.Strength = 1.5 		-- Option "Much Destruction" '

	- 4. 
		1. Change the number "1.8" in line 95      (registerSlipDestroysFields.Strength = 1.8   -- Option "Little Destruction") to change the destruction amount for the selected option "Little Destruction".

		2.  Change the number "1.65" in line 97      (registerSlipDestroysFields.Strength = 1.65   -- Option "Medium Destruction") to change the destruction amount for the selected option "Medium Destruction".

		3.  Change the number "1.8" in line 99      (registerSlipDestroysFields.Strength = 1.8   -- Option "Much Destruction") to change the destruction amount for the selected option "Much Destruction".


		!The numbers are very sensitive and do not need to be changed much to notice a change. Even a change of 0.1 has a remarkable impact!

	- 5. Save the edited file
	
	- 6. Zip the mod
	
	- 7. Insert the now zipped mod into your mod folder
	
	- 8. Delete the unzipped version of the mod


##Deutsch##

-Schritt-für-Schritt-Anleitung zum Anpassen der Werte-

	- 1. Entpacken sie den Mod
	
	- 2. Öffnen Sie die Datei "registerSlipDestroysFields.lua"

	- 3. Suchen Sie die Zeilen 	'registerSlipDestroysFields.Strength = 1.8 		-- Option "Little Destruction" ' 	am Ende des Skripts (Zeilen 95-99)
								'registerSlipDestroysFields.Strength = 1.65 	-- Option "Medium Destruction" '
								'registerSlipDestroysFields.Strength = 1.5 		-- Option "Much Destruction" '
	
	- 4. 
		1. Ändern Sie die Zahl "1.8" in Zeile 95 (registerSlipDestroysFields.Strength = 1.8 -- Option "Little Destruction"), um die Zerstörungsstärke für die gewählte Option "Geringe Zerstörung" zu ändern.

		2.  Ändern Sie die Zahl "1.65" in Zeile 97 (registerSlipDestroysFields.Strength = 1.65 -- Option "Medium Destruction"), um den Zerstörungsgrad für die gewählte Option "Mittlere Zerstörung" zu ändern.

		3.  Ändern Sie die Zahl "1.8" in Zeile 98 (registerSlipDestroysFields.Strength = 1.8 -- Option "Much Destruction"), um den Zerstörungsgrad für die gewählte Option "Viel Zerstörung" zu ändern.


		!Die Zahlen sind sehr empfindlich und müssen nicht viel geändert werden, um eine Änderung zu bemerken. Selbst eine Änderung von 0,1 hat eine bemerkenswerte Auswirkung!

	- 5. Speichern Sie die bearbeitete Datei
	
	- 6. Packen Sie den Mod
	
	- 7. Fügen Sie den nun gepackten Mod in Ihren Modordner ein
	
	- 8. Löschen Sie die ungepackte Version des Mods


##Français##

-Guide étape par étape pour ajuster les valeurs-

	- 1. Dézipper le Mod

	- 2. Ouvrir le fichier "registerSlipDestroysFields.lua"

	- Recherchez les lignes 	'registerSlipDestroysFields.Strength = 1.8 	-- Option "Little Destruction"'			 à la fin du script (lignes 95-99)
								'registerSlipDestroysFields.Strength = 1.65 -- Option "Medium Destruction" '
								'registerSlipDestroysFields.Strength = 1.5 	-- Option "Much Destruction" '

	- 4. 
		1. Modifiez le nombre "1,8" à la ligne 95 (registerSlipDestroysFields.Strength = 1,8 -- Option "Little Destruction") pour modifier la quantité de destruction pour l'option sélectionnée "Petite de destruction"

		2.  Changez le nombre "1.65" dans la ligne 97 (registerSlipDestroysFields.Strength = 1.65 -- Option "Medium Destruction") pour changer le montant de destruction pour l'option sélectionnée "Moyen de destruction"

		3.  Changez le nombre "1.8" dans la ligne 99 (registerSlipDestroysFields.Strength = 1.8 -- Option "Much Destruction") pour changer le montant de destruction pour l'option sélectionnée "Beaucoup de destruction"


		! Les chiffres sont très sensibles et il n'est pas nécessaire de les modifier beaucoup pour remarquer un changement. Même un changement de 0,1 a un impact remarquable !

	- 5. Enregistrez le fichier modifié
	
	- 6. Zippez le mod
	
	- 7. Insérez le mod maintenant zippé dans votre dossier de mods
	
	- 8. Supprimez la version non compressée du module
--]]

SlipDestroysFields = {};
SlipDestroysFields.l10nEnv = "FS22_SlipDestroysFields";

function SlipDestroysFields.prerequisitesPresent(specializations)
	return true;
end;

function SlipDestroysFields.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdateTick", SlipDestroysFields);
end;

function SlipDestroysFields:onLoad(savegame)
	local spec = self.spec_SlipDestroysFields

	spec.maxSlip = 0
end

function SlipDestroysFields.loadedMission(mission, node)
    if mission:getIsServer() then
        if mission.missionInfo.savegameDirectory ~= nil and fileExists(mission.missionInfo.savegameDirectory .. "/SlipDestroysFields.xml") then
            local xmlFile = XMLFile.load("SlipDestroysFields", mission.missionInfo.savegameDirectory .. "/SlipDestroysFields.xml")
            if xmlFile ~= nil then
				registerSlipDestroysFields.StrengthState = xmlFile:getFloat("SlipDestroysFields.StrengthState", registerSlipDestroysFields.StrengthState)
				registerSlipDestroysFields.Strength = xmlFile:getFloat("SlipDestroysFields.Strength", registerSlipDestroysFields.Strength)
                xmlFile:delete()
            end
        end
    end
    if mission.cancelLoading then
        return
    end
end

function SlipDestroysFields.saveToXMLFile(missionInfo)
	 if missionInfo.isValid then
        local xmlFile = XMLFile.create("SlipDestroysFields", missionInfo.savegameDirectory .. "/SlipDestroysFields.xml", "SlipDestroysFields")
        if xmlFile ~= nil then
			xmlFile:setFloat("SlipDestroysFields.StrengthState", registerSlipDestroysFields.StrengthState)
			xmlFile:setFloat("SlipDestroysFields.Strength", registerSlipDestroysFields.Strength)
            xmlFile:save()
            xmlFile:delete()
        end
    end
end

function SlipDestroysFields:onUpdateTick(dt, isActiveForInput, isActiveForInputIgnoreSelection, isSelected)
	if self.isClient and isActiveForInputIgnoreSelection then
		local spec = self.spec_SlipDestroysFields
		
		----------------------------------------------------------------------------------------
		-- calculate the speed of the vehicle + steering angle
		----------------------------------------------------------------------------------------
		local refSpeed = math.max( self.lastSpeed * 1000, 0.544 )
		spec.maxSlip = registerSlipDestroysFields.Strength			-- minimum percentage of slip for destruction
		
		if     self.rotatedTime < -1E-9 then 
			spec.maxSlip = spec.maxSlip + 0.4 * self.rotatedTime / self.minRotTime
		elseif self.rotatedTime >  1E-9 then 
			spec.maxSlip = spec.maxSlip + 0.4 * self.rotatedTime / self.maxRotTime
		end 
		spec.maxSlip = spec.maxSlip * refSpeed

		for wheelIndex,_ in pairs(self.spec_wheels.wheels) do
			local wheel = self.spec_wheels.wheels[wheelIndex]
			----------------------------------------------------------------------------------------
			-- need this to check if REAwheels and REAcog are activated. (Doesnt work properly with them because the rolling resistance let's the wheel be faster as it is when stopping the vehicle)
			----------------------------------------------------------------------------------------
			if wheel.RollingMovingDirection ~= nil and self.COGChangedByREA ~= nil and wheel.RollingMovingDirection ~= 0 then
				self.spec_wheels.isAddedToPhysics = false
				wheel.RollingMovingDirection = 0
			end
			
			local lastTooFast = wheel.TooFast
			wheel.TooFast = nil
			
			----------------------------------------------------------------------------------------
			-- calculate wheel speed + a minimum number for the wheel speed
			----------------------------------------------------------------------------------------
			if not ( wheel.hasGroundContact ) or wheel.AvgWheelSpeed == nil then 
				wheel.AvgWheelSpeed = math.abs(refSpeed)
			else
				sw = getWheelShapeAxleSpeed(wheel.node, wheel.wheelShape) * wheel.radius
				wheel.AvgWheelSpeed = math.abs(0.5 * (wheel.AvgWheelSpeed + sw))
				sw = math.min(sw, wheel.AvgWheelSpeed)
				
				----------------------------------------------------------------------------------------
				-- check if wheel speed is higher than the vehicle speed
				----------------------------------------------------------------------------------------
				if wheel.AvgWheelSpeed >= 1.8 then
					if math.abs(sw) >= 0.544 and wheel.AvgWheelSpeed > spec.maxSlip then
						----------------------------------------------------------------------------------------
						-- use this to add a limit of maximum destruction at one destruction
						----------------------------------------------------------------------------------------
						if lastTooFast == nil then 
							wheel.TooFast = g_currentMission.time 
						else 
							wheel.TooFast = lastTooFast
						end

						----------------------------------------------------------------------------------------
						-- calculate wheel size and change the ground
						----------------------------------------------------------------------------------------
						local width = 0.3 * wheel.width
						local length = math.min(0.3, 0.3 * wheel.width)
						local x, _, z = localToLocal(wheel.driveNode, wheel.repr, 0, 0, 0)
						local x0, y0, z0 = localToWorld(wheel.repr, x + width, 0, z - length)
						local x1, y1, z1 = localToWorld(wheel.repr, x - width, 0, z - length)
						local x2, y2, z2 = localToWorld(wheel.repr, x + width, 0, z + length)

						if self:getIsOnField() then
							FSDensityMapUtil.updateCultivatorArea(x0, z0, x1, z1, x2, z2, true, true, nil, nil)
						end

						if wheel.additionalWheels ~= nil then
							for _, additionalWheel in pairs(wheel.additionalWheels) do
								local width = 0.3 * additionalWheel.width
								local length = math.min(0.3, 0.3 * additionalWheel.width)
								local refNode = wheel.node

								if wheel.repr ~= wheel.driveNode then
									refNode = wheel.repr
								end

								local xShift, yShift, zShift = localToLocal(additionalWheel.wheelTire, refNode, 0, 0, 0)
								local x0, y0, z0 = localToWorld(refNode, xShift + width, yShift, zShift - length)
								local x1, y1, z1 = localToWorld(refNode, xShift - width, yShift, zShift - length)
								local x2, y2, z2 = localToWorld(refNode, xShift + width, yShift, zShift + length)

								if self:getIsOnField() then
									FSDensityMapUtil.updateCultivatorArea(x0, z0, x1, z1, x2, z2, true, true, nil, nil)
								end
								g_currentMission:showBlinkingWarning(("ZERSTÖRT Boden! (Wenn auf Feld)(%1.50f)"):format(wheel.AvgWheelSpeed - spec.maxSlip), 1000)
							end
						end
					end
				end
				
			end
		end
	end
end

if SlipDestroysFields.loaded == nil then
	SlipDestroysFields.loaded = true
	
	Mission00.loadMission00Finished = Utils.appendedFunction(Mission00.loadMission00Finished, SlipDestroysFields.loadedMission);
	FSCareerMissionInfo.saveToXMLFile = Utils.appendedFunction(FSCareerMissionInfo.saveToXMLFile, SlipDestroysFields.saveToXMLFile);
end