-- by Frvetz
-- Contact: SlipDestroysFields@web.de
-- Date 09.05.2022


--[[


TUTORIAL


##English##

-Step-To-Step Guide for adjusting the values-

	- 1. Unzip the Mod

	- 2. Open the file "registerSlipDestroysFields.lua"

	- 3. Look for the lines 	'registerSlipDestroysFields.Strength = 1.8		-- Option "Little Destruction" '		at the end of the script (lines 95-99)
								'registerSlipDestroysFields.Strength = 1.65 	-- Option "Medium Destruction" '
								'registerSlipDestroysFields.Strength = 1.5 		-- Option "Much Destruction" '

	- 4. 
		1. Change the number "1.8" in line 95      (registerSlipDestroysFields.Strength = 1.8   -- Option "Little Destruction") to change the destruction amount for the selected option "Little Destruction".

		2.  Change the number "1.65" in line 97      (registerSlipDestroysFields.Strength = 1.65   -- Option "Medium Destruction") to change the destruction amount for the selected option "Medium Destruction".

		3.  Change the number "1.8" in line 99      (registerSlipDestroysFields.Strength = 1.8   -- Option "Much Destruction") to change the destruction amount for the selected option "Much Destruction".


		!The numbers are very sensitive and do not need to be changed much to notice a change. Even a change of 0.1 has a remarkable impact!

	- 5. Save the edited file
	
	- 6. Zip the mod
	
	- 7. Insert the now zipped mod into your mod folder
	
	- 8. Delete the unzipped version of the mod


##Deutsch##

-Schritt-für-Schritt-Anleitung zum Anpassen der Werte-

	- 1. Entpacken sie den Mod
	
	- 2. Öffnen Sie die Datei "registerSlipDestroysFields.lua"

	- 3. Suchen Sie die Zeilen 	'registerSlipDestroysFields.Strength = 1.8 		-- Option "Little Destruction" ' 	am Ende des Skripts (Zeilen 95-99)
								'registerSlipDestroysFields.Strength = 1.65 	-- Option "Medium Destruction" '
								'registerSlipDestroysFields.Strength = 1.5 		-- Option "Much Destruction" '
	
	- 4. 
		1. Ändern Sie die Zahl "1.8" in Zeile 95 (registerSlipDestroysFields.Strength = 1.8 -- Option "Little Destruction"), um die Zerstörungsstärke für die gewählte Option "Geringe Zerstörung" zu ändern.

		2.  Ändern Sie die Zahl "1.65" in Zeile 97 (registerSlipDestroysFields.Strength = 1.65 -- Option "Medium Destruction"), um den Zerstörungsgrad für die gewählte Option "Mittlere Zerstörung" zu ändern.

		3.  Ändern Sie die Zahl "1.8" in Zeile 98 (registerSlipDestroysFields.Strength = 1.8 -- Option "Much Destruction"), um den Zerstörungsgrad für die gewählte Option "Viel Zerstörung" zu ändern.


		!Die Zahlen sind sehr empfindlich und müssen nicht viel geändert werden, um eine Änderung zu bemerken. Selbst eine Änderung von 0,1 hat eine bemerkenswerte Auswirkung!

	- 5. Speichern Sie die bearbeitete Datei
	
	- 6. Packen Sie den Mod
	
	- 7. Fügen Sie den nun gepackten Mod in Ihren Modordner ein
	
	- 8. Löschen Sie die ungepackte Version des Mods


##Français##

-Guide étape par étape pour ajuster les valeurs-

	- 1. Dézipper le Mod

	- 2. Ouvrir le fichier "registerSlipDestroysFields.lua"

	- Recherchez les lignes 	'registerSlipDestroysFields.Strength = 1.8 	-- Option "Little Destruction"'			 à la fin du script (lignes 95-99)
								'registerSlipDestroysFields.Strength = 1.65 -- Option "Medium Destruction" '
								'registerSlipDestroysFields.Strength = 1.5 	-- Option "Much Destruction" '

	- 4. 
		1. Modifiez le nombre "1,8" à la ligne 95 (registerSlipDestroysFields.Strength = 1,8 -- Option "Little Destruction") pour modifier la quantité de destruction pour l'option sélectionnée "Petite de destruction"

		2.  Changez le nombre "1.65" dans la ligne 97 (registerSlipDestroysFields.Strength = 1.65 -- Option "Medium Destruction") pour changer le montant de destruction pour l'option sélectionnée "Moyen de destruction"

		3.  Changez le nombre "1.8" dans la ligne 99 (registerSlipDestroysFields.Strength = 1.8 -- Option "Much Destruction") pour changer le montant de destruction pour l'option sélectionnée "Beaucoup de destruction"


		! Les chiffres sont très sensibles et il n'est pas nécessaire de les modifier beaucoup pour remarquer un changement. Même un changement de 0,1 a un impact remarquable !

	- 5. Enregistrez le fichier modifié
	
	- 6. Zippez le mod
	
	- 7. Insérez le mod maintenant zippé dans votre dossier de mods
	
	- 8. Supprimez la version non compressée du module
--]]


registerSlipDestroysFields = {}
registerSlipDestroysFields.Strength = 1.25
registerSlipDestroysFields.StrengthState = 2;
registerSlipDestroysFields.specName = "SlipDestroysFields"
registerSlipDestroysFields.className = "SlipDestroysFields"
registerSlipDestroysFields.fileName = g_currentModDirectory.."SlipDestroysFields.lua"

function registerSlipDestroysFields:registerSpecialization()

	local specName = registerSlipDestroysFields.specName

	if g_specializationManager:getSpecializationByName(specName) == nil then
		g_specializationManager:addSpecialization(registerSlipDestroysFields.specName, registerSlipDestroysFields.className, registerSlipDestroysFields.fileName, "")

		for vehicleType, vehicle in pairs(g_vehicleTypeManager.types) do

			if vehicle ~= nil and vehicleType ~= "locomotive" and vehicleType ~= "ConveyorBelt" and vehicleType ~= "woodCrusherTrailerDrivable" and vehicleType ~= "baleWrapper" then

				local isDrivable = false;
				local hasNotRGE = true;

				for name, spec in pairs(vehicle.specializationsByName) do
					if name == "drivable" then
						isDrivable = true;
					elseif name == "SlipDestroysFields" then
						hasNotRGE = false;
					end
				end
				if hasNotRGE and isDrivable then
					print("  adding SlipDestroysFields to vehicleType '"..tostring(vehicleType).."'")

					local specObject = g_specializationManager:getSpecializationObjectByName(specName);

					vehicle.specializationsByName[specName] = specObject;
					table.insert(vehicle.specializationNames, specName);
					table.insert(vehicle.specializations, specObject);
				end
			end
		end
	end
end
registerSlipDestroysFields:registerSpecialization()

function init()
	InGameMenuGameSettingsFrame.onFrameOpen = Utils.appendedFunction(InGameMenuGameSettingsFrame.onFrameOpen, registerSlipDestroysFields.installGUI)
    InGameMenuGameSettingsFrame.updateGameSettings = Utils.appendedFunction(InGameMenuGameSettingsFrame.updateGameSettings, registerSlipDestroysFields.updateSlipDestroysFieldsGui)	
end


function registerSlipDestroysFields:installGUI()
	if not self.initSDFGuiDone then
		self.SDF = self.checkDirt:clone()
		self.SDF.target = registerSlipDestroysFields
		self.SDF.id = "SDF"
		self.SDF:setCallback("onClickCallback", "onSlipDestroysFieldsModeChanged")


		self.SDF.elements[4]:setText(g_i18n:getText("setting_SlipDestroysFields"))
		self.SDF.elements[6]:setText(g_i18n:getText("explanation_SlipDestroysFields"))
		
		local title = TextElement.new()
		title:applyProfile("settingsMenuSubtitle", true)
		title:setText(g_i18n:getText("title_SlipDestroysFields"))

		self.boxLayout:addElement(title)
		self.boxLayout:addElement(self.SDF)

		self.SDF:setTexts({g_i18n:getText("selection_SlipDestroysFields_Light"), g_i18n:getText("selection_SlipDestroysFields_Medium"), g_i18n:getText("selection_SlipDestroysFields_Heavy"), g_i18n:getText("selection_SlipDestroysFields_None")})
		
		self.initSDFGuiDone = true
		self.SDF:setState(registerSlipDestroysFields.StrengthState)
	end
end

function registerSlipDestroysFields.updateSlipDestroysFieldsGui(self)
    if self.initSDFGuiDone and self.SDF ~= nil then
        self.SDF:setState(registerSlipDestroysFields.StrengthState)
    end
end

function registerSlipDestroysFields:onSlipDestroysFieldsModeChanged(state)
	registerSlipDestroysFields.StrengthState = state;
	if state == 1 then
		registerSlipDestroysFields.Strength = 1.8	-- Option "Little Destruction"
	elseif state == 2 then
		registerSlipDestroysFields.Strength = 1.65	-- Option "Medium Destruction"
	elseif state == 3 then
		registerSlipDestroysFields.Strength = 1.5	-- Option "Much Destruction"
	else
		registerSlipDestroysFields.Strength = 10000	-- Option "No Destruction"
	end
end



init()
-- make localizations available
local i18nTable = getfenv(0).g_i18n
for l18nId,l18nText in pairs(g_i18n.texts) do
  i18nTable:setText(l18nId, l18nText)
end